# RUBYLIB=~/cvswork/amrita/lib rd2 -r ../sample/tour/rd2html-amrita-lib.rb  --html-title='amrita home page' index.rd|w3m -T text/html

((<Japanese|URL:index_ja.html>))

= amrita home page

== What is amrita ?

Amrita is an html/xhtml template library for Ruby. 
It makes html documents from a template and model data.

=== Key feature

* The template for amrita is a pure html/xhtml document without
  special tags like <?...?> or <% .. %>

* The template can be written by designers using almost any html
  editor.

* There's no need to change Ruby code to modify the view of the 
  _dynamic_ part of the template (or the static portion).

* The model data may be any standard Ruby data-- a Hash, Array, 
  String... or an instance of any user-defined class.

* The output is controlled by _data_, not by logic-- so it's easy to
  write, test, and debug code. (Good for eXtremeProgramming)

* The html template can be compiled into Ruby code before execution
  with little effort.

Amrita uses a template and model data to create an html document by
naturally matching the +id+ attribute of an html element to model data.

== documents

* ((<README|URL:rdocs/files/README.html>))
* ((<Quick Start Guide|URL:rdocs/files/docs/QuickStart.html>))
* ((<Tour|URL:rdocs/files/docs/Tour.html>))

== download

* stable-version 
  ((: pt[:TARBALL][:name=>'amrita', :ver=>'1.0.2'] :))

* unstable-version 
  ((: pt[:TARBALL][:name=>'amrita', :ver=>'1.8.2'] :))

* cvs repository

      $ cvs -d ":pserver:guest@cvs.walrus-ruby.org:/var/lib/cvs" login 
       password: (no password type just return)
      $ cvs -d ":pserver:guest@cvs.walrus-ruby.org:/var/lib/cvs" co amrita

* ((<see sources|URL:sources>))

* ((<see ChangeLog|URL:sources/ChangeLog>))

== unstable version

The next maijor version of amrita is under development now.

* ((<RELEASENOTE|URL:unstable/docs/html/files/RELEASENOTE.html>))
* ((<see sources|URL:unstable/>))
* ((<see ChangeLog|URL:unstable/ChangeLog>))

=== New feature

* improvement of performance

  * virtual machine architecuture
  * on-demand compilation and partial compiling
  * amcc -- static template to C compiler

* Amulet

* expand attr 


== links

* ((<amrita Wiki|AMRITA:IndexPage>))
* ((<amrita mailing list|AMRITA:AmritaUsers>))


